#ifndef _menu
#define _menu

/// typ wyliczeniowy stanw przycisku
enum przycisk_zdarzenie
{
  KLIKNIECIE, NAJECHANIE, NORMALNY, ZWOLNIENIE
};

/// klasa obslugujca menu gwne gry
class menu
{
  protected:
    /// wskaniki na potrzebne obiekty z zewntrz klasy
    grafika * engine;
    char wybrana_mapa[100];
    short wybrana_gra;
    
    bool u_dzwiek;
  public:
    /// funkcja wywietla menu gwne i obsuguje zdarzenia, zwraca cieke do wybranej
	  /// mapy
    short pokaz();
    /// konstruktor klasy menu
    menu(grafika *);
    /// funkcja wyswietlajaca okno z podanym tekstem w danym miejscu
    short okno(int, int, char *, char *, char *);
    /// funkcja rysuje miniature mapy z pliku w odpowienie miejsce
    void miniatura(char *, int, int, int);
    char * wczytana_mapa();
    short wczytana_gra();
    short zwroc_ustawienia(short);
};

//******************************************************************************

/// klasa sluzy do wyswietlania oraz obslugi zdarzen przycisku
class przycisk
{
      private:
        /// wskaniki na potrzebne obiekty z zewntrz klasy        
        grafika *engine;
        /// pooenie przycisku
        int x;
        int y;
        /// aktualny stan przycisku
        przycisk_zdarzenie aktualny;
        /// etykieta na przycisku      
        char * tekst;
       
      public:
         /// konstruktor do klasy przycisk
         przycisk(grafika *,int,int,char* );
         /// destruktor klasy przycisk
         ~przycisk();
         /// funkcja odswieza status przycisku
         przycisk_zdarzenie zdarzenie();
         /// funkcja wyswietla przycisk w zaleznosci od stanu w jakim sie znajduje 
         /// wraz z etykieta
         void rysuj();
         /// funkcja przesuwa przycisk w dane miejsce
         void przesun(int, int);
         /// funkcja zmienia tekst przycisku na wybrany
         void napis(char *);
};


#include "menu.cpp"

#endif
